/*-
 * Copyright (C)2019..2024 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ident "@(#) Copyright (C)2019..2024 @BABOLO http://www.babolo.ru/\n"
#ident "@(#) $Id: pip.c,v 1.3 2024/01/14 16:37:40 babolo Exp $\n"

#define BLIN_COMPAT 4
#define MIFE_COMPAT VMAJOR

#include <sys/types.h>
#include <sys/event.h>
#include <sys/time.h>
#include <sysexits.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <babolo/BLINflag.h>
#include "../mife.h"

int
main(int argc, char **argv) {
    ssize_t          reedsize;
    BLIN_flag        flags;
    int              optc;
    mife_descriptor *mf;
    int              fd;

    flags = BLIN_BIT0;
    while ((optc = getopt(argc, argv, "v")) > 0) {
        switch (optc) {
        case 'v': /******** verbose            ********/
                  BLIN_VERBOSE(flags);
                  break;
        default:
                  exit(EX_USAGE);
    }   }
    if  (0 > (fd = fileno(stdin))) {
        exit(EX_IOERR);
    }
    mf = mife_init(flags);
    if  (mife_ctlfdsc(mf, fd)) {
        exit(EX_IOERR);
    }
    reedsize = mife_read(mf, 0, 0);
    printf("reedsize=%"BLIN_D" EoF=%d\n", reedsize, !!(mf->flags & MIFE_EOFL));
    exit(EX_OK);
}
